ZeroCouponInflationSwap Class Reference

Zero-coupon inflation-indexed swap. More...

`#include <ql/instruments/zerocouponinflationswap.hpp>`

Inheritance diagram for ZeroCouponInflationSwap:
[legend]

## Public Types

enum | Type { Receiver = -1, Payer = 1 }
Public Types inherited from Observer
typedef std::set< boost::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator

## Public Member Functions

ZeroCouponInflationSwap (Type type, Real nominal, const Date &startDate, const Date &maturity, const Calendar &fixCalendar, BusinessDayConvention fixConvention, const DayCounter &dayCounter, Rate fixedRate, const boost::shared_ptr< ZeroInflationIndex > &infIndex, const Period &observationLag, bool adjustInfObsDates=false, Calendar infCalendar=Calendar(), BusinessDayConvention infConvention=BusinessDayConvention())

Inspectors
Type | type () const
| "payer" or "receiver" refer to the inflation-indexed leg
Real | nominal () const
Date | startDate () const
Date | maturityDate () const
Calendar | fixedCalendar () const
BusinessDayConvention | fixedConvention () const
DayCounter | dayCounter () const
Rate | fixedRate () const
| \( K \) in the above formula.
boost::shared_ptr< ZeroInflationIndex > | inflationIndex () const
Period | observationLag () const
bool | adjustObservationDates () const
Calendar | inflationCalendar () const
BusinessDayConvention | inflationConvention () const
const Leg & | fixedLeg () const
| just one cashflow (that is not a coupon) in each leg
const Leg & | inflationLeg () const
| just one cashflow (that is not a coupon) in each leg
Instrument interface
void | setupArguments (PricingEngine::arguments *) const
void | fetchResults (const PricingEngine::results *r) const
Results
Real | fixedLegNPV () const
Real | inflationLegNPV () const
Real | fairRate () const
Public Member Functions inherited from Swap
Date | startDate () const
Date | maturityDate () const
Real | legBPS (Size j) const
Real | legNPV (Size j) const
DiscountFactor | startDiscounts (Size j) const
DiscountFactor | endDiscounts (Size j) const
DiscountFactor | npvDateDiscount () const
const Leg & | leg (Size j) const
| Swap (const Leg &firstLeg, const Leg &secondLeg)
| Swap (const std::vector< Leg > &legs, const std::vector< bool > &payer)
bool | isExpired () const
| returns whether the instrument might have value greater than zero.
Public Member Functions inherited from Instrument
Real | NPV () const
| returns the net present value of the instrument.
Real | errorEstimate () const
| returns the error estimate on the NPV when available.
const Date & | valuationDate () const
| returns the date the net present value refers to.
template<typename T >
T | result (const std::string &tag) const
| returns any additional result returned by the pricing engine.
const std::map< std::string, boost::any > & | additionalResults () const
| returns all additional result returned by the pricing engine.
void | setPricingEngine (const boost::shared_ptr< PricingEngine > &)
| set the pricing engine to be used. More...
Public Member Functions inherited from LazyObject
void | update ()
void | recalculate ()
void | freeze ()
void | unfreeze ()
void | alwaysForwardNotifications ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()

## Protected Attributes

Type | type_
Real | nominal_
Date | startDate_
Date | maturityDate_
Calendar | fixCalendar_
BusinessDayConvention | fixConvention_
Rate | fixedRate_
boost::shared_ptr< ZeroInflationIndex > | infIndex_
Period | observationLag_
bool | adjustInfObsDates_
Calendar | infCalendar_
BusinessDayConvention | infConvention_
DayCounter | dayCounter_
Date | baseDate_
Date | obsDate_
Protected Attributes inherited from Swap
std::vector< Leg > | legs_
std::vector< Real > | payer_
std::vector< Real > | legNPV_
std::vector< Real > | legBPS_
std::vector< DiscountFactor > | startDiscounts_
std::vector< DiscountFactor > | endDiscounts_
DiscountFactor | npvDateDiscount_
Protected Attributes inherited from Instrument
boost::shared_ptr< PricingEngine > | engine_
Real | NPV_
Real | errorEstimate_
Date | valuationDate_
std::map< std::string, boost::any > | additionalResults_
Protected Attributes inherited from LazyObject
bool | calculated_
bool | frozen_
bool | alwaysForward_

## Additional Inherited Members

Protected Member Functions inherited from Swap
| Swap (Size legs)
void | setupExpired () const
Protected Member Functions inherited from Instrument
void | calculate () const
virtual void | performCalculations () const
Protected Member Functions inherited from LazyObject

## Detailed Description

Zero-coupon inflation-indexed swap.

Quoted as a fixed rate \( K \). At start:

\[ P_n(0,T) N [(1+K)^{T}-1] = P_n(0,T) N \left[ \frac{I(T)}{I(0)} -1 \right] \]

where \( T \) is the maturity time, \( P_n(0,t) \) is the nominal discount factor at time \( t \), \( N \) is the notional, and \( I(t) \) is the inflation index value at time \( t \).

This inherits from swap and has two very simple legs: a fixed leg, from the quote (K); and an indexed leg. At maturity the two single cashflows are swapped. These are the notional versus the inflation-indexed notional Because the coupons are zero there are no accruals (and no coupons).

Inflation is generally available on every day, including holidays and weekends. Hence there is a variable to state whether the observe/fix dates for inflation are adjusted or not. The default is not to adjust.

A zero inflation swap is a simple enough instrument that the standard discounting pricing engine that works for a vanilla swap also works.

Note
  we do not need Schedules on the legs because they use one or two dates only per leg.

## Member Function Documentation

## setupArguments()

void setupArguments | ( | PricingEngine::arguments * |  | ) | const

virtual

When a derived argument structure is defined for an instrument, this method should be overridden to fill it. This is mandatory in case a pricing engine is used.

Reimplemented from Swap.

## fetchResults()

void fetchResults | ( | const PricingEngine::results * | r | ) | const

virtual

When a derived result structure is defined for an instrument, this method should be overridden to read from it. This is mandatory in case a pricing engine is used.

Reimplemented from Swap.